import { HttpClient, EventDefinition, MaybeContext, BuildRESTFunction, BuildEventDefinition } from '@wix/sdk-types';
import { P as PortfolioSettings, G as GetPortfolioSettingsResponse, U as UpdatePortfolioSettingsResponse, a as PortfolioSettingsCreatedEnvelope } from './portfolio-portfolio-app-v1-portfolio-settings-portfolio-settings.universal-BgJqvP95.js';
export { j as ActionEvent, A as AddItemDirection, B as BaseEventMetadata, C as CreatePortfolioSettingsRequest, c as CreatePortfolioSettingsResponse, D as DefaultItemName, f as DomainEvent, g as DomainEventBodyOneOf, E as EntityCreatedEvent, i as EntityDeletedEvent, h as EntityUpdatedEvent, m as EventMetadata, d as GetPortfolioSettingsRequest, I as IdentificationData, l as IdentificationDataIdOneOf, M as MediaSettings, k as MessageEnvelope, b as ProjectItemSettings, R as RestoreInfo, S as SiteMenuSettings, e as UpdatePortfolioSettingsRequest, W as WebhookIdentityType } from './portfolio-portfolio-app-v1-portfolio-settings-portfolio-settings.universal-BgJqvP95.js';

declare function createPortfolioSettings$1(httpClient: HttpClient): CreatePortfolioSettingsSignature;
interface CreatePortfolioSettingsSignature {
    /**
     * Creates a site's portfolio settings.
     *
     * > **Note:**
     * >
     * > This method is intended for creating portfolio settings. If settings already exist, the request will return an error. To update existing settings, call [Update Portfolio Settings](https://dev.wix.com/docs/rest/business-solutions/portfolio/portfolio-settings/update-portfolio-settings).
     * @param - The portfolio settings to create.
     * @returns Newly created portfolio settings.
     */
    (portfolioSettings: PortfolioSettings): Promise<PortfolioSettings>;
}
declare function getPortfolioSettings$1(httpClient: HttpClient): GetPortfolioSettingsSignature;
interface GetPortfolioSettingsSignature {
    /**
     * Retrieves a site's portfolio settings.
     */
    (): Promise<GetPortfolioSettingsResponse>;
}
declare function updatePortfolioSettings$1(httpClient: HttpClient): UpdatePortfolioSettingsSignature;
interface UpdatePortfolioSettingsSignature {
    /**
     * Updates a site's portfolio settings.
     * @param - The portfolio settings to update.
     */
    (portfolioSettings: PortfolioSettings): Promise<UpdatePortfolioSettingsResponse>;
}
declare const onPortfolioSettingsCreated$1: EventDefinition<PortfolioSettingsCreatedEnvelope, "wix.portfolio.portfolio_app.v1.portfolio_settings_created">;

declare const createPortfolioSettings: MaybeContext<BuildRESTFunction<typeof createPortfolioSettings$1> & typeof createPortfolioSettings$1>;
declare const getPortfolioSettings: MaybeContext<BuildRESTFunction<typeof getPortfolioSettings$1> & typeof getPortfolioSettings$1>;
declare const updatePortfolioSettings: MaybeContext<BuildRESTFunction<typeof updatePortfolioSettings$1> & typeof updatePortfolioSettings$1>;
/**
 * Triggered when portfolio settings are created.
 */
declare const onPortfolioSettingsCreated: BuildEventDefinition<typeof onPortfolioSettingsCreated$1>;

export { GetPortfolioSettingsResponse, PortfolioSettings, PortfolioSettingsCreatedEnvelope, UpdatePortfolioSettingsResponse, createPortfolioSettings, getPortfolioSettings, onPortfolioSettingsCreated, updatePortfolioSettings };
