"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// index.ts
var index_exports = {};
__export(index_exports, {
  AddItemDirection: () => AddItemDirection,
  DefaultItemName: () => DefaultItemName,
  WebhookIdentityType: () => WebhookIdentityType,
  createPortfolioSettings: () => createPortfolioSettings4,
  getPortfolioSettings: () => getPortfolioSettings4,
  onPortfolioSettingsCreated: () => onPortfolioSettingsCreated2,
  updatePortfolioSettings: () => updatePortfolioSettings4
});
module.exports = __toCommonJS(index_exports);

// src/portfolio-portfolio-app-v1-portfolio-settings-portfolio-settings.public.ts
var import_rename_all_nested_keys2 = require("@wix/sdk-runtime/rename-all-nested-keys");
var import_timestamp3 = require("@wix/sdk-runtime/transformations/timestamp");
var import_transform_paths2 = require("@wix/sdk-runtime/transformations/transform-paths");
var import_sdk_types = require("@wix/sdk-types");

// src/portfolio-portfolio-app-v1-portfolio-settings-portfolio-settings.universal.ts
var import_transform_error = require("@wix/sdk-runtime/transform-error");
var import_rename_all_nested_keys = require("@wix/sdk-runtime/rename-all-nested-keys");

// src/portfolio-portfolio-app-v1-portfolio-settings-portfolio-settings.http.ts
var import_rest_modules = require("@wix/sdk-runtime/rest-modules");
var import_timestamp = require("@wix/sdk-runtime/transformations/timestamp");
var import_timestamp2 = require("@wix/sdk-runtime/transformations/timestamp");
var import_field_mask = require("@wix/sdk-runtime/transformations/field-mask");
var import_transform_paths = require("@wix/sdk-runtime/transformations/transform-paths");
var import_rest_modules2 = require("@wix/sdk-runtime/rest-modules");
function resolveComWixpressPortfolioPortfolioappPortfolioSettingsServiceUrl(opts) {
  const domainToMappings = {
    "manage._base_domain_": [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    "editor._base_domain_": [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    "blocks._base_domain_": [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    "create.editorx": [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    _: [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    "api._api_base_domain_": [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    "www.wixapis.com": [
      {
        srcPath: "/portfolio/v1/settings",
        destPath: "/api/v1/portfolio/settings"
      },
      {
        srcPath: "/portfolio/portfolio-app/api/v1/portfolio/settings",
        destPath: "/api/v1/portfolio/settings"
      },
      {
        srcPath: "/portfolio/project-items/api/v1/portfolio/project/items/media",
        destPath: "/api/v1/portfolio/project/items/media"
      }
    ],
    "*.dev.wix-code.com": [
      {
        srcPath: "/portfolio/portfolio-app/api/v1/portfolio/settings",
        destPath: "/api/v1/portfolio/settings"
      },
      {
        srcPath: "/portfolio/project-items/api/v1/portfolio/project/items/media",
        destPath: "/api/v1/portfolio/project/items/media"
      }
    ]
  };
  return (0, import_rest_modules2.resolveUrl)(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_portfolio_portfolio-settings";
function createPortfolioSettings(payload) {
  function __createPortfolioSettings({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_timestamp.transformSDKTimestampToRESTTimestamp,
        paths: [
          { path: "portfolioSettings.createdDate" },
          { path: "portfolioSettings.updatedDate" }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.portfolio.portfolio_app.v1.portfolio_settings",
      method: "POST",
      methodFqn: "com.wixpress.portfolio.portfolioapp.PortfolioSettingsService.CreatePortfolioSettings",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressPortfolioPortfolioappPortfolioSettingsServiceUrl({
        protoPath: "/api/v1/portfolio/settings",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "portfolioSettings.createdDate" },
            { path: "portfolioSettings.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __createPortfolioSettings;
}
function getPortfolioSettings(payload) {
  function __getPortfolioSettings({ host }) {
    const metadata = {
      entityFqdn: "wix.portfolio.portfolio_app.v1.portfolio_settings",
      method: "GET",
      methodFqn: "com.wixpress.portfolio.portfolioapp.PortfolioSettingsService.GetPortfolioSettings",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressPortfolioPortfolioappPortfolioSettingsServiceUrl({
        protoPath: "/api/v1/portfolio/settings",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload),
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "portfolioSettings.createdDate" },
            { path: "portfolioSettings.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __getPortfolioSettings;
}
function updatePortfolioSettings(payload) {
  function __updatePortfolioSettings({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_field_mask.transformSDKFieldMaskToRESTFieldMask,
        paths: [{ path: "mask" }]
      },
      {
        transformFn: import_timestamp.transformSDKTimestampToRESTTimestamp,
        paths: [
          { path: "portfolioSettings.createdDate" },
          { path: "portfolioSettings.updatedDate" }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.portfolio.portfolio_app.v1.portfolio_settings",
      method: "PATCH",
      methodFqn: "com.wixpress.portfolio.portfolioapp.PortfolioSettingsService.UpdatePortfolioSettings",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressPortfolioPortfolioappPortfolioSettingsServiceUrl({
        protoPath: "/api/v1/portfolio/settings",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "updatedPortfolioSettings.createdDate" },
            { path: "updatedPortfolioSettings.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __updatePortfolioSettings;
}

// src/portfolio-portfolio-app-v1-portfolio-settings-portfolio-settings.universal.ts
var AddItemDirection = /* @__PURE__ */ ((AddItemDirection2) => {
  AddItemDirection2["GALLERY_START"] = "GALLERY_START";
  AddItemDirection2["GALLERY_END"] = "GALLERY_END";
  return AddItemDirection2;
})(AddItemDirection || {});
var DefaultItemName = /* @__PURE__ */ ((DefaultItemName2) => {
  DefaultItemName2["FILE_NAME"] = "FILE_NAME";
  DefaultItemName2["EMPTY"] = "EMPTY";
  return DefaultItemName2;
})(DefaultItemName || {});
var WebhookIdentityType = /* @__PURE__ */ ((WebhookIdentityType2) => {
  WebhookIdentityType2["UNKNOWN"] = "UNKNOWN";
  WebhookIdentityType2["ANONYMOUS_VISITOR"] = "ANONYMOUS_VISITOR";
  WebhookIdentityType2["MEMBER"] = "MEMBER";
  WebhookIdentityType2["WIX_USER"] = "WIX_USER";
  WebhookIdentityType2["APP"] = "APP";
  return WebhookIdentityType2;
})(WebhookIdentityType || {});
async function createPortfolioSettings2(portfolioSettings) {
  const { httpClient, sideEffects } = arguments[1];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    portfolioSettings
  });
  const reqOpts = createPortfolioSettings(
    payload
  );
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(result.data)?.portfolioSettings;
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: { portfolioSettings: "$[0]" },
        singleArgumentUnchanged: false
      },
      ["portfolioSettings"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function getPortfolioSettings2() {
  const { httpClient, sideEffects } = arguments[0];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({});
  const reqOpts = getPortfolioSettings(
    payload
  );
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(result.data);
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {},
        singleArgumentUnchanged: false
      },
      []
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function updatePortfolioSettings2(portfolioSettings) {
  const { httpClient, sideEffects } = arguments[1];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    portfolioSettings
  });
  const reqOpts = updatePortfolioSettings(
    payload
  );
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(result.data);
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: { portfolioSettings: "$[0]" },
        singleArgumentUnchanged: false
      },
      ["portfolioSettings"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}

// src/portfolio-portfolio-app-v1-portfolio-settings-portfolio-settings.public.ts
function createPortfolioSettings3(httpClient) {
  return (portfolioSettings) => createPortfolioSettings2(
    portfolioSettings,
    // @ts-ignore
    { httpClient }
  );
}
function getPortfolioSettings3(httpClient) {
  return () => getPortfolioSettings2(
    // @ts-ignore
    { httpClient }
  );
}
function updatePortfolioSettings3(httpClient) {
  return (portfolioSettings) => updatePortfolioSettings2(
    portfolioSettings,
    // @ts-ignore
    { httpClient }
  );
}
var onPortfolioSettingsCreated = (0, import_sdk_types.EventDefinition)(
  "wix.portfolio.portfolio_app.v1.portfolio_settings_created",
  true,
  (event) => (0, import_rename_all_nested_keys2.renameKeysFromRESTResponseToSDKResponse)(
    (0, import_transform_paths2.transformPaths)(event, [
      {
        transformFn: import_timestamp3.transformRESTTimestampToSDKTimestamp,
        paths: [
          { path: "entity.createdDate" },
          { path: "entity.updatedDate" },
          { path: "metadata.eventTime" }
        ]
      }
    ])
  )
)();

// src/portfolio-portfolio-app-v1-portfolio-settings-portfolio-settings.context.ts
var import_rest_modules3 = require("@wix/sdk-runtime/rest-modules");
var import_event_definition_modules = require("@wix/sdk-runtime/event-definition-modules");
var createPortfolioSettings4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(createPortfolioSettings3);
var getPortfolioSettings4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(getPortfolioSettings3);
var updatePortfolioSettings4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(updatePortfolioSettings3);
var onPortfolioSettingsCreated2 = (0, import_event_definition_modules.createEventModule)(onPortfolioSettingsCreated);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  AddItemDirection,
  DefaultItemName,
  WebhookIdentityType,
  createPortfolioSettings,
  getPortfolioSettings,
  onPortfolioSettingsCreated,
  updatePortfolioSettings
});
//# sourceMappingURL=index.js.map