// src/portfolio-portfolio-app-v1-portfolio-settings-portfolio-settings.public.ts
import { renameKeysFromRESTResponseToSDKResponse as renameKeysFromRESTResponseToSDKResponse2 } from "@wix/sdk-runtime/rename-all-nested-keys";
import { transformRESTTimestampToSDKTimestamp as transformRESTTimestampToSDKTimestamp2 } from "@wix/sdk-runtime/transformations/timestamp";
import { transformPaths as transformPaths2 } from "@wix/sdk-runtime/transformations/transform-paths";
import { EventDefinition } from "@wix/sdk-types";

// src/portfolio-portfolio-app-v1-portfolio-settings-portfolio-settings.universal.ts
import { transformError as sdkTransformError } from "@wix/sdk-runtime/transform-error";
import {
  renameKeysFromSDKRequestToRESTRequest,
  renameKeysFromRESTResponseToSDKResponse
} from "@wix/sdk-runtime/rename-all-nested-keys";

// src/portfolio-portfolio-app-v1-portfolio-settings-portfolio-settings.http.ts
import { toURLSearchParams } from "@wix/sdk-runtime/rest-modules";
import { transformSDKTimestampToRESTTimestamp } from "@wix/sdk-runtime/transformations/timestamp";
import { transformRESTTimestampToSDKTimestamp } from "@wix/sdk-runtime/transformations/timestamp";
import { transformSDKFieldMaskToRESTFieldMask } from "@wix/sdk-runtime/transformations/field-mask";
import { transformPaths } from "@wix/sdk-runtime/transformations/transform-paths";
import { resolveUrl } from "@wix/sdk-runtime/rest-modules";
function resolveComWixpressPortfolioPortfolioappPortfolioSettingsServiceUrl(opts) {
  const domainToMappings = {
    "manage._base_domain_": [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    "editor._base_domain_": [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    "blocks._base_domain_": [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    "create.editorx": [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    _: [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    "api._api_base_domain_": [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    "www.wixapis.com": [
      {
        srcPath: "/portfolio/v1/settings",
        destPath: "/api/v1/portfolio/settings"
      },
      {
        srcPath: "/portfolio/portfolio-app/api/v1/portfolio/settings",
        destPath: "/api/v1/portfolio/settings"
      },
      {
        srcPath: "/portfolio/project-items/api/v1/portfolio/project/items/media",
        destPath: "/api/v1/portfolio/project/items/media"
      }
    ],
    "*.dev.wix-code.com": [
      {
        srcPath: "/portfolio/portfolio-app/api/v1/portfolio/settings",
        destPath: "/api/v1/portfolio/settings"
      },
      {
        srcPath: "/portfolio/project-items/api/v1/portfolio/project/items/media",
        destPath: "/api/v1/portfolio/project/items/media"
      }
    ]
  };
  return resolveUrl(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_portfolio_portfolio-settings";
function createPortfolioSettings(payload) {
  function __createPortfolioSettings({ host }) {
    const serializedData = transformPaths(payload, [
      {
        transformFn: transformSDKTimestampToRESTTimestamp,
        paths: [
          { path: "portfolioSettings.createdDate" },
          { path: "portfolioSettings.updatedDate" }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.portfolio.portfolio_app.v1.portfolio_settings",
      method: "POST",
      methodFqn: "com.wixpress.portfolio.portfolioapp.PortfolioSettingsService.CreatePortfolioSettings",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressPortfolioPortfolioappPortfolioSettingsServiceUrl({
        protoPath: "/api/v1/portfolio/settings",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => transformPaths(payload2, [
        {
          transformFn: transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "portfolioSettings.createdDate" },
            { path: "portfolioSettings.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __createPortfolioSettings;
}
function getPortfolioSettings(payload) {
  function __getPortfolioSettings({ host }) {
    const metadata = {
      entityFqdn: "wix.portfolio.portfolio_app.v1.portfolio_settings",
      method: "GET",
      methodFqn: "com.wixpress.portfolio.portfolioapp.PortfolioSettingsService.GetPortfolioSettings",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressPortfolioPortfolioappPortfolioSettingsServiceUrl({
        protoPath: "/api/v1/portfolio/settings",
        data: payload,
        host
      }),
      params: toURLSearchParams(payload),
      transformResponse: (payload2) => transformPaths(payload2, [
        {
          transformFn: transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "portfolioSettings.createdDate" },
            { path: "portfolioSettings.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __getPortfolioSettings;
}
function updatePortfolioSettings(payload) {
  function __updatePortfolioSettings({ host }) {
    const serializedData = transformPaths(payload, [
      {
        transformFn: transformSDKFieldMaskToRESTFieldMask,
        paths: [{ path: "mask" }]
      },
      {
        transformFn: transformSDKTimestampToRESTTimestamp,
        paths: [
          { path: "portfolioSettings.createdDate" },
          { path: "portfolioSettings.updatedDate" }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.portfolio.portfolio_app.v1.portfolio_settings",
      method: "PATCH",
      methodFqn: "com.wixpress.portfolio.portfolioapp.PortfolioSettingsService.UpdatePortfolioSettings",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressPortfolioPortfolioappPortfolioSettingsServiceUrl({
        protoPath: "/api/v1/portfolio/settings",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => transformPaths(payload2, [
        {
          transformFn: transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "updatedPortfolioSettings.createdDate" },
            { path: "updatedPortfolioSettings.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __updatePortfolioSettings;
}

// src/portfolio-portfolio-app-v1-portfolio-settings-portfolio-settings.universal.ts
var AddItemDirection = /* @__PURE__ */ ((AddItemDirection2) => {
  AddItemDirection2["GALLERY_START"] = "GALLERY_START";
  AddItemDirection2["GALLERY_END"] = "GALLERY_END";
  return AddItemDirection2;
})(AddItemDirection || {});
var DefaultItemName = /* @__PURE__ */ ((DefaultItemName2) => {
  DefaultItemName2["FILE_NAME"] = "FILE_NAME";
  DefaultItemName2["EMPTY"] = "EMPTY";
  return DefaultItemName2;
})(DefaultItemName || {});
var WebhookIdentityType = /* @__PURE__ */ ((WebhookIdentityType2) => {
  WebhookIdentityType2["UNKNOWN"] = "UNKNOWN";
  WebhookIdentityType2["ANONYMOUS_VISITOR"] = "ANONYMOUS_VISITOR";
  WebhookIdentityType2["MEMBER"] = "MEMBER";
  WebhookIdentityType2["WIX_USER"] = "WIX_USER";
  WebhookIdentityType2["APP"] = "APP";
  return WebhookIdentityType2;
})(WebhookIdentityType || {});
async function createPortfolioSettings2(portfolioSettings) {
  const { httpClient, sideEffects } = arguments[1];
  const payload = renameKeysFromSDKRequestToRESTRequest({
    portfolioSettings
  });
  const reqOpts = createPortfolioSettings(
    payload
  );
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return renameKeysFromRESTResponseToSDKResponse(result.data)?.portfolioSettings;
  } catch (err) {
    const transformedError = sdkTransformError(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: { portfolioSettings: "$[0]" },
        singleArgumentUnchanged: false
      },
      ["portfolioSettings"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function getPortfolioSettings2() {
  const { httpClient, sideEffects } = arguments[0];
  const payload = renameKeysFromSDKRequestToRESTRequest({});
  const reqOpts = getPortfolioSettings(
    payload
  );
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return renameKeysFromRESTResponseToSDKResponse(result.data);
  } catch (err) {
    const transformedError = sdkTransformError(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {},
        singleArgumentUnchanged: false
      },
      []
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function updatePortfolioSettings2(portfolioSettings) {
  const { httpClient, sideEffects } = arguments[1];
  const payload = renameKeysFromSDKRequestToRESTRequest({
    portfolioSettings
  });
  const reqOpts = updatePortfolioSettings(
    payload
  );
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return renameKeysFromRESTResponseToSDKResponse(result.data);
  } catch (err) {
    const transformedError = sdkTransformError(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: { portfolioSettings: "$[0]" },
        singleArgumentUnchanged: false
      },
      ["portfolioSettings"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}

// src/portfolio-portfolio-app-v1-portfolio-settings-portfolio-settings.public.ts
function createPortfolioSettings3(httpClient) {
  return (portfolioSettings) => createPortfolioSettings2(
    portfolioSettings,
    // @ts-ignore
    { httpClient }
  );
}
function getPortfolioSettings3(httpClient) {
  return () => getPortfolioSettings2(
    // @ts-ignore
    { httpClient }
  );
}
function updatePortfolioSettings3(httpClient) {
  return (portfolioSettings) => updatePortfolioSettings2(
    portfolioSettings,
    // @ts-ignore
    { httpClient }
  );
}
var onPortfolioSettingsCreated = EventDefinition(
  "wix.portfolio.portfolio_app.v1.portfolio_settings_created",
  true,
  (event) => renameKeysFromRESTResponseToSDKResponse2(
    transformPaths2(event, [
      {
        transformFn: transformRESTTimestampToSDKTimestamp2,
        paths: [
          { path: "entity.createdDate" },
          { path: "entity.updatedDate" },
          { path: "metadata.eventTime" }
        ]
      }
    ])
  )
)();

// src/portfolio-portfolio-app-v1-portfolio-settings-portfolio-settings.context.ts
import { createRESTModule } from "@wix/sdk-runtime/rest-modules";
import { createEventModule } from "@wix/sdk-runtime/event-definition-modules";
var createPortfolioSettings4 = /* @__PURE__ */ createRESTModule(createPortfolioSettings3);
var getPortfolioSettings4 = /* @__PURE__ */ createRESTModule(getPortfolioSettings3);
var updatePortfolioSettings4 = /* @__PURE__ */ createRESTModule(updatePortfolioSettings3);
var onPortfolioSettingsCreated2 = createEventModule(onPortfolioSettingsCreated);
export {
  AddItemDirection,
  DefaultItemName,
  WebhookIdentityType,
  createPortfolioSettings4 as createPortfolioSettings,
  getPortfolioSettings4 as getPortfolioSettings,
  onPortfolioSettingsCreated2 as onPortfolioSettingsCreated,
  updatePortfolioSettings4 as updatePortfolioSettings
};
//# sourceMappingURL=index.mjs.map