"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// meta.ts
var meta_exports = {};
__export(meta_exports, {
  createPortfolioSettings: () => createPortfolioSettings2,
  getPortfolioSettings: () => getPortfolioSettings2,
  updatePortfolioSettings: () => updatePortfolioSettings2
});
module.exports = __toCommonJS(meta_exports);

// src/portfolio-portfolio-app-v1-portfolio-settings-portfolio-settings.http.ts
var import_rest_modules = require("@wix/sdk-runtime/rest-modules");
var import_timestamp = require("@wix/sdk-runtime/transformations/timestamp");
var import_timestamp2 = require("@wix/sdk-runtime/transformations/timestamp");
var import_field_mask = require("@wix/sdk-runtime/transformations/field-mask");
var import_transform_paths = require("@wix/sdk-runtime/transformations/transform-paths");
var import_rest_modules2 = require("@wix/sdk-runtime/rest-modules");
function resolveComWixpressPortfolioPortfolioappPortfolioSettingsServiceUrl(opts) {
  const domainToMappings = {
    "manage._base_domain_": [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    "editor._base_domain_": [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    "blocks._base_domain_": [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    "create.editorx": [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    _: [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    "api._api_base_domain_": [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    "www.wixapis.com": [
      {
        srcPath: "/portfolio/v1/settings",
        destPath: "/api/v1/portfolio/settings"
      },
      {
        srcPath: "/portfolio/portfolio-app/api/v1/portfolio/settings",
        destPath: "/api/v1/portfolio/settings"
      },
      {
        srcPath: "/portfolio/project-items/api/v1/portfolio/project/items/media",
        destPath: "/api/v1/portfolio/project/items/media"
      }
    ],
    "*.dev.wix-code.com": [
      {
        srcPath: "/portfolio/portfolio-app/api/v1/portfolio/settings",
        destPath: "/api/v1/portfolio/settings"
      },
      {
        srcPath: "/portfolio/project-items/api/v1/portfolio/project/items/media",
        destPath: "/api/v1/portfolio/project/items/media"
      }
    ]
  };
  return (0, import_rest_modules2.resolveUrl)(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_portfolio_portfolio-settings";
function createPortfolioSettings(payload) {
  function __createPortfolioSettings({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_timestamp.transformSDKTimestampToRESTTimestamp,
        paths: [
          { path: "portfolioSettings.createdDate" },
          { path: "portfolioSettings.updatedDate" }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.portfolio.portfolio_app.v1.portfolio_settings",
      method: "POST",
      methodFqn: "com.wixpress.portfolio.portfolioapp.PortfolioSettingsService.CreatePortfolioSettings",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressPortfolioPortfolioappPortfolioSettingsServiceUrl({
        protoPath: "/api/v1/portfolio/settings",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "portfolioSettings.createdDate" },
            { path: "portfolioSettings.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __createPortfolioSettings;
}
function getPortfolioSettings(payload) {
  function __getPortfolioSettings({ host }) {
    const metadata = {
      entityFqdn: "wix.portfolio.portfolio_app.v1.portfolio_settings",
      method: "GET",
      methodFqn: "com.wixpress.portfolio.portfolioapp.PortfolioSettingsService.GetPortfolioSettings",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressPortfolioPortfolioappPortfolioSettingsServiceUrl({
        protoPath: "/api/v1/portfolio/settings",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload),
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "portfolioSettings.createdDate" },
            { path: "portfolioSettings.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __getPortfolioSettings;
}
function updatePortfolioSettings(payload) {
  function __updatePortfolioSettings({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_field_mask.transformSDKFieldMaskToRESTFieldMask,
        paths: [{ path: "mask" }]
      },
      {
        transformFn: import_timestamp.transformSDKTimestampToRESTTimestamp,
        paths: [
          { path: "portfolioSettings.createdDate" },
          { path: "portfolioSettings.updatedDate" }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.portfolio.portfolio_app.v1.portfolio_settings",
      method: "PATCH",
      methodFqn: "com.wixpress.portfolio.portfolioapp.PortfolioSettingsService.UpdatePortfolioSettings",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressPortfolioPortfolioappPortfolioSettingsServiceUrl({
        protoPath: "/api/v1/portfolio/settings",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "updatedPortfolioSettings.createdDate" },
            { path: "updatedPortfolioSettings.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __updatePortfolioSettings;
}

// src/portfolio-portfolio-app-v1-portfolio-settings-portfolio-settings.meta.ts
function createPortfolioSettings2() {
  const payload = {};
  const getRequestOptions = createPortfolioSettings(
    payload
  );
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "POST",
    path: "/api/v1/portfolio/settings",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function getPortfolioSettings2() {
  const payload = {};
  const getRequestOptions = getPortfolioSettings(
    payload
  );
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "GET",
    path: "/api/v1/portfolio/settings",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function updatePortfolioSettings2() {
  const payload = {};
  const getRequestOptions = updatePortfolioSettings(
    payload
  );
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "PATCH",
    path: "/api/v1/portfolio/settings",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createPortfolioSettings,
  getPortfolioSettings,
  updatePortfolioSettings
});
//# sourceMappingURL=meta.js.map