// src/portfolio-portfolio-app-v1-portfolio-settings-portfolio-settings.http.ts
import { toURLSearchParams } from "@wix/sdk-runtime/rest-modules";
import { transformSDKTimestampToRESTTimestamp } from "@wix/sdk-runtime/transformations/timestamp";
import { transformRESTTimestampToSDKTimestamp } from "@wix/sdk-runtime/transformations/timestamp";
import { transformSDKFieldMaskToRESTFieldMask } from "@wix/sdk-runtime/transformations/field-mask";
import { transformPaths } from "@wix/sdk-runtime/transformations/transform-paths";
import { resolveUrl } from "@wix/sdk-runtime/rest-modules";
function resolveComWixpressPortfolioPortfolioappPortfolioSettingsServiceUrl(opts) {
  const domainToMappings = {
    "manage._base_domain_": [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    "editor._base_domain_": [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    "blocks._base_domain_": [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    "create.editorx": [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    _: [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    "api._api_base_domain_": [
      {
        srcPath: "/_api/portfolio-app-service",
        destPath: "/api"
      }
    ],
    "www.wixapis.com": [
      {
        srcPath: "/portfolio/v1/settings",
        destPath: "/api/v1/portfolio/settings"
      },
      {
        srcPath: "/portfolio/portfolio-app/api/v1/portfolio/settings",
        destPath: "/api/v1/portfolio/settings"
      },
      {
        srcPath: "/portfolio/project-items/api/v1/portfolio/project/items/media",
        destPath: "/api/v1/portfolio/project/items/media"
      }
    ],
    "*.dev.wix-code.com": [
      {
        srcPath: "/portfolio/portfolio-app/api/v1/portfolio/settings",
        destPath: "/api/v1/portfolio/settings"
      },
      {
        srcPath: "/portfolio/project-items/api/v1/portfolio/project/items/media",
        destPath: "/api/v1/portfolio/project/items/media"
      }
    ]
  };
  return resolveUrl(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_portfolio_portfolio-settings";
function createPortfolioSettings(payload) {
  function __createPortfolioSettings({ host }) {
    const serializedData = transformPaths(payload, [
      {
        transformFn: transformSDKTimestampToRESTTimestamp,
        paths: [
          { path: "portfolioSettings.createdDate" },
          { path: "portfolioSettings.updatedDate" }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.portfolio.portfolio_app.v1.portfolio_settings",
      method: "POST",
      methodFqn: "com.wixpress.portfolio.portfolioapp.PortfolioSettingsService.CreatePortfolioSettings",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressPortfolioPortfolioappPortfolioSettingsServiceUrl({
        protoPath: "/api/v1/portfolio/settings",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => transformPaths(payload2, [
        {
          transformFn: transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "portfolioSettings.createdDate" },
            { path: "portfolioSettings.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __createPortfolioSettings;
}
function getPortfolioSettings(payload) {
  function __getPortfolioSettings({ host }) {
    const metadata = {
      entityFqdn: "wix.portfolio.portfolio_app.v1.portfolio_settings",
      method: "GET",
      methodFqn: "com.wixpress.portfolio.portfolioapp.PortfolioSettingsService.GetPortfolioSettings",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressPortfolioPortfolioappPortfolioSettingsServiceUrl({
        protoPath: "/api/v1/portfolio/settings",
        data: payload,
        host
      }),
      params: toURLSearchParams(payload),
      transformResponse: (payload2) => transformPaths(payload2, [
        {
          transformFn: transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "portfolioSettings.createdDate" },
            { path: "portfolioSettings.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __getPortfolioSettings;
}
function updatePortfolioSettings(payload) {
  function __updatePortfolioSettings({ host }) {
    const serializedData = transformPaths(payload, [
      {
        transformFn: transformSDKFieldMaskToRESTFieldMask,
        paths: [{ path: "mask" }]
      },
      {
        transformFn: transformSDKTimestampToRESTTimestamp,
        paths: [
          { path: "portfolioSettings.createdDate" },
          { path: "portfolioSettings.updatedDate" }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.portfolio.portfolio_app.v1.portfolio_settings",
      method: "PATCH",
      methodFqn: "com.wixpress.portfolio.portfolioapp.PortfolioSettingsService.UpdatePortfolioSettings",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressPortfolioPortfolioappPortfolioSettingsServiceUrl({
        protoPath: "/api/v1/portfolio/settings",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => transformPaths(payload2, [
        {
          transformFn: transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "updatedPortfolioSettings.createdDate" },
            { path: "updatedPortfolioSettings.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __updatePortfolioSettings;
}

// src/portfolio-portfolio-app-v1-portfolio-settings-portfolio-settings.meta.ts
function createPortfolioSettings2() {
  const payload = {};
  const getRequestOptions = createPortfolioSettings(
    payload
  );
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "POST",
    path: "/api/v1/portfolio/settings",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function getPortfolioSettings2() {
  const payload = {};
  const getRequestOptions = getPortfolioSettings(
    payload
  );
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "GET",
    path: "/api/v1/portfolio/settings",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function updatePortfolioSettings2() {
  const payload = {};
  const getRequestOptions = updatePortfolioSettings(
    payload
  );
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "PATCH",
    path: "/api/v1/portfolio/settings",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
export {
  createPortfolioSettings2 as createPortfolioSettings,
  getPortfolioSettings2 as getPortfolioSettings,
  updatePortfolioSettings2 as updatePortfolioSettings
};
//# sourceMappingURL=meta.mjs.map